var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
define("RequestPool.types", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("RequestPool", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ConcurrentRequestPool = void 0;
    var ConcurrentRequestPool = /** @class */ (function () {
        function ConcurrentRequestPool(_a) {
            var _this = this;
            var _b = _a === void 0 ? {} : _a, limit = _b.limit, type = _b.type;
            this.counter = 0;
            this.tubes = {
                default: {
                    index: 1,
                    jobs: [],
                    counter: 0,
                    limit: 0,
                    enabled: true,
                    type: 'pop',
                }
            };
            this.push = function (_a) {
                var tube = _a.tube, action = _a.action;
                var id;
                if (!action) {
                    console.log("RequestPool->push: You must provide action field with async action to push new job");
                    return false;
                }
                if (!tube) {
                    id = _this.tubes.default.index++;
                    _this.tubes.default.jobs.push({
                        id: id,
                        action: action
                    });
                }
                else if (_this.tubes[tube]) {
                    if (_this.tubes[tube].enabled) {
                        id = _this.tubes[tube].index++;
                        _this.tubes[tube].jobs.push({
                            id: id,
                            action: action
                        });
                    }
                    else {
                        console.log("RequestPool->push: Tube with name " + tube + " is disabled, enable tube before push new jobs inside");
                        return false;
                    }
                }
                else {
                    console.log("RequestPool->push: There are no tube with name " + tube + ", create tube before push jobs inside");
                    return false;
                }
                _this.processQueue();
                return id;
            };
            this.remove = function (_a) {
                var tube = _a.tube, id = _a.id;
                if (!tube) {
                    _this.tubes.default.jobs = _this.tubes.default.jobs.filter(function (job) { return job.id !== id; });
                }
                else if (_this.tubes[tube]) {
                    _this.tubes[tube].jobs = _this.tubes[tube].jobs.filter(function (job) { return job.id !== id; });
                }
                else {
                    console.log("RequestPool->remove: There are no tube with name " + tube + ", create tube before remove jobs from it");
                    return false;
                }
                return true;
            };
            this.createTube = function (_a) {
                var name = _a.name, _b = _a.limit, limit = _b === void 0 ? 0 : _b, type = _a.type;
                if (_this.tubes[name]) {
                    console.log("RequestPool->createTube: Tube with name " + name + " already exists");
                    return false;
                }
                _this.tubes[name] = {
                    limit: limit,
                    index: 1,
                    counter: 0,
                    jobs: [],
                    enabled: true,
                    type: type ? type : _this.type,
                };
                return true;
            };
            this.removeTube = function (_a) {
                var name = _a.name;
                if (name === 'default') {
                    console.log("RequestPool->push: Can't remove default tube");
                    return false;
                }
                if (_this.tubes[name]) {
                    var jobs = __spreadArrays(_this.tubes[name].jobs);
                    delete _this.tubes[name];
                    return jobs;
                }
                else {
                    console.log("RequestPool->removeTube: There are no tube with name " + name + ", create tube before remove it");
                    return false;
                }
            };
            this.enableTube = function (_a) {
                var name = _a.name;
                if (_this.tubes[name]) {
                    _this.tubes[name].enabled = true;
                    _this.processTube(_this.tubes[name]);
                    return true;
                }
                else {
                    console.log("RequestPool->enableTube: There are no tube with name " + name + ", create tube before enable it");
                    return false;
                }
            };
            this.disableTube = function (_a) {
                var name = _a.name;
                if (_this.tubes[name]) {
                    _this.tubes[name].enabled = false;
                    return true;
                }
                else {
                    console.log("RequestPool->disableTube: There are no tube with name " + name + ", create tube before disable it");
                    return false;
                }
            };
            this.processTube = function (tube) {
                if (_this.limit === 0 || (_this.counter < _this.limit)) {
                    if (tube.enabled) {
                        if (tube.limit === 0 || (tube.counter < tube.limit)) {
                            if (tube.jobs.length) {
                                var job = void 0;
                                if (tube.type === 'pop') {
                                    job = tube.jobs.pop();
                                }
                                else {
                                    job = tube.jobs.shift();
                                }
                                tube.counter++;
                                _this.counter++;
                                job.action().finally(function () {
                                    _this.counter--;
                                    tube.counter--;
                                    _this.processTube(tube);
                                });
                                _this.processTube(tube);
                            }
                        }
                    }
                }
            };
            this.processQueue = function () {
                var tubes = Object.keys(_this.tubes);
                tubes.forEach(function (tube) {
                    _this.processTube(_this.tubes[tube]);
                });
            };
            this.limit = limit || 0;
            this.type = type || 'pop';
            this.tubes.default.limit = limit || 0;
            this.tubes.default.type = type || 'pop';
        }
        Object.defineProperty(ConcurrentRequestPool.prototype, "state", {
            get: function () {
                return {
                    tubes: __assign({}, this.tubes),
                    limit: this.limit,
                    type: this.type,
                    counter: this.counter,
                };
            },
            enumerable: false,
            configurable: true
        });
        ;
        return ConcurrentRequestPool;
    }());
    exports.ConcurrentRequestPool = ConcurrentRequestPool;
});
define("index", ["require", "exports", "RequestPool"], function (require, exports, RequestPool_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ConcurrentRequestPool = void 0;
    Object.defineProperty(exports, "ConcurrentRequestPool", { enumerable: true, get: function () { return RequestPool_1.ConcurrentRequestPool; } });
});
